#!/usr/bin/env node
import { execSync as l } from "node:child_process";
import g, { resolve as M } from "node:path";
import u, { existsSync as $, rmSync as d } from "node:fs";
import { log as r, xPrompts as c, lookForParentTarget as _ } from "@done-coding/cli-utils";
import { getConfigPath as F, batchHandler as O } from "@done-coding/cli-template";
import { getTargetRepoUrl as S } from "@done-coding/cli-git";
import b from "yargs";
import { hideBin as L } from "yargs/helpers";
const p = {
  version: "0.9.4-alpha.0",
  name: "create-done-coding",
  description: "项目创建命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "create"
  }
}, N = "git@gitee.com:justsosu/done-coding-cli-config-json.git", j = "自定义模版路径", C = "某个git平台用户仓库", I = `./.${p.name}_temp`;
let v;
const U = async () => (v || (v = (await J()).templateList), v), x = async () => [
  ...await U(),
  { name: j },
  { name: C }
], A = {
  type: "text",
  name: "projectName",
  message: "请输入项目名称",
  format: (e) => e.trim(),
  validate: (e) => e.length > 0 || "项目名称不能为空"
}, H = async () => ({
  type: "select",
  name: "template",
  message: "请选择模板",
  choices: (await x()).map((t) => {
    var n;
    return {
      title: t.branch ? `${t.name}(${t.branch})` : t.name,
      value: t.name,
      description: `${t.description || ""}${(n = t.instances) != null && n.length ? `, 已应用于: ${[""].concat(t.instances).join(`
- `)}` : ""}` || void 0
    };
  }),
  validate: (t) => t.trim().length > 0 || "模板不能为空"
}), B = {
  type: "confirm",
  name: "saveGitHistory",
  message: "是否保留git历史",
  initial: !1
}, E = (e = "项目已存在，是否删除") => ({
  type: "confirm",
  name: "isRemove",
  message: e
}), k = {
  type: "text",
  name: "customUrl",
  message: "请输入自定义模板路径",
  validate: (e) => e.trim().length > 0 || "路径不能为空"
}, Y = (e) => ({
  type: "text",
  name: "gitCommitMessage",
  message: "请输入git提交信息",
  initial: `feat: 初始化项目${e}`,
  validate: (t) => t.trim().length > 0 || "提交信息不能为空"
}), J = async () => {
  r.stage("拉取模板列表，请稍等...");
  const e = g.resolve(
    process.cwd(),
    I
  );
  if ($(e))
    return r.error(`${e} 已存在，请手动删除该目录再试`), process.exit(1);
  if (r.info(`配置临时目录：${e}`), u.existsSync(e)) {
    const n = `${e}目录已存在，是否删除？`, { isRemove: o } = await c(E(n));
    if (o)
      u.rmSync(e, { recursive: !0, force: !0 });
    else
      return r.error(`${e} 已存在，请手动删除该目录再试`), process.exit(1);
  }
  let t;
  try {
    l(`git clone ${N} ${e} --depth=1`);
    const n = p.name, o = g.resolve(e, `${n}.json`);
    if (t = JSON.parse(u.readFileSync(o, "utf-8")), !Array.isArray(t.templateList)) {
      const i = `远程配置文件出错, templateList 不是数组, 请检查 ${N} ${n}.json`;
      throw new Error(i);
    }
    r.success("模板列表拉取成功！");
  } finally {
    u.rmSync(e, { recursive: !0, force: !0 });
  }
  return t;
}, G = async (e) => {
  const { projectName: t } = e, o = ((t ?? (await c(A)).projectName) || "").trim();
  if (!o)
    return r.error("项目名称不能为空"), process.exit(1);
  if (o.includes(" ") || o.includes("\\") || o.includes("/"))
    return r.error(`项目名称\`${o}\`不能包含空格或者\\或者/`), process.exit(1);
  const i = M(process.cwd(), o);
  if ($(i)) {
    const { isRemove: s } = await c(E());
    if (s === !0)
      d(i, { recursive: !0, force: !0 });
    else
      return r.error(`项目${o}已存在`), process.exit(1);
  }
  const { template: m } = await c(await H());
  let f = "", h = "";
  if (m === j) {
    const { customUrl: s } = await c(k);
    f = s;
  } else if (m === C)
    f = await S();
  else {
    const s = (await x()).find(
      (a) => a.name === m
    );
    if (!s)
      return r.error(`模板${m}不存在`), process.exit(1);
    if (!s.url)
      return r.error(`模板${m}仓库地址不存在`), process.exit(1);
    f = s.url, h = s.branch;
  }
  const y = _(".git");
  r.stage("正在初始化项目，请稍等..."), l(
    `git clone${h ? ` -b ${h}` : ""} ${f} ${o} --depth=1`,
    { stdio: "inherit" }
  );
  const w = F(i);
  if (w && (await O({
    rootDir: i,
    extraEnvData: {
      $projectName: o
    }
  }), d(w, { force: !0 }), r.stage("模板项目配置注入成功, 模版项目配置文件已删除")), r.stage("项目初始化完成"), y) {
    const s = g.resolve(i), a = g.resolve(s, ".git");
    if (!$(a))
      throw new Error("git目录不存在");
    d(a, { recursive: !0, force: !0 }), r.stage(
      `项目创建在父级git仓库${y}中，已删除${o}目录下的.git(${a})`
    );
  } else if ((await c(B)).saveGitHistory)
    l("git remote rename origin upstream && git fetch --unshallow", {
      cwd: i,
      stdio: "inherit"
    }), r.stage(
      "已经将origin重命名为upstream，后续可以与模板git仓库有完整的交互"
    ), r.success("已保存git历史记录");
  else {
    const a = g.resolve(i, ".git");
    d(a, { recursive: !0, force: !0 }), l("git init", {
      cwd: i,
      stdio: "inherit"
    });
  }
  const { gitCommitMessage: D } = await c(
    Y(o)
  );
  l(`git add . && git commit -m '${D}'`, {
    cwd: i,
    stdio: "inherit"
  }), r.success(`项目${o}初始化完成`), r.info(`
使用步骤: 
  1. cd ${o}
  2. pnpm install
  3. pnpm run dev
  `);
}, T = p.cliConfig.moduleName, q = (e, t) => {
  e ? r.error(e) : r.error(t.message), process.exit(1);
}, P = p.description, z = `$0 ${T} [projectName]`, K = "$0 [projectName]", R = async (e, t) => e.strict().usage(`Usage: ${t}`).help("help").version(p.version).alias("v", "version").alias("h", "help").command({
  command: t,
  describe: P,
  handler: G
}).fail(q).argv, oe = {
  command: T,
  describe: P,
  builder: (e) => R(e, z),
  handler: G
}, ie = async () => {
  const e = b(L(process.argv));
  return await R(e, K);
};
export {
  oe as a,
  ie as c,
  G as h
};
